<template>
  <div class="mb-4">
    <label for="wasm-file" class="block mb-2">Upload WASM file:</label>
    <div class="flex">
      <input id="wasm-file" type="file" accept=".wasm" @change="onFileChange" class="border rounded px-2 py-1 mr-2"
        :class="{ 'bg-gray-800 text-white border-gray-700': props.isDarkMode }" />
      <input v-model="wasmName" type="text" placeholder="WASM name" class="border rounded px-2 py-1 mr-2"
        :class="{ 'bg-gray-800 text-white border-gray-700': props.isDarkMode }" />
      <button @click="uploadWasm" class="px-4 py-1 rounded"
        :class="{ 'bg-blue-600 text-white': props.isDarkMode, 'bg-blue-500 text-white': !props.isDarkMode }">
        Upload
      </button>
    </div>
    <div class="mt-4">
      <label for="wasm-select" class="block mb-2">Select current parser:</label>
      <select id="wasm-select" v-model="selectedWasm" @change="onWasmSelect" class="border rounded px-2 py-1"
        :class="{ 'bg-gray-800 text-white border-gray-700': props.isDarkMode }">
        <option value="">Select a parser</option>
        <optgroup label="Pre-built parsers">
          <option v-for="parser in prebuiltParsers" :key="parser" :value="parser">{{ parser }}</option>
        </optgroup>
        <optgroup label="Custom parsers">
          <option v-for="wasm in wasmFiles" :key="wasm.name" :value="wasm.name">
            {{ wasm.name }} ({{  wasm.filename  }})
          </option>
        </optgroup>
      </select>
    </div>
    <div v-if="wasmFiles.length > 0" class="mt-4">
      <h3 class="text-lg font-bold mb-2">Custom Parsers</h3>
      <div class="grid grid-cols-1 sm:grid-cols-2 md:grid-cols-3 gap-4">
        <div v-for="wasm in wasmFiles" :key="wasm.name" class="border rounded p-4"
          :class="{ 'bg-gray-800 text-white border-gray-700': props.isDarkMode }">
          <div class="font-bold">{{ wasm.name }}</div>
          <div class="text-sm">Size: {{ formatFileSize(wasm.attachment.size) }}</div>
          <div class="text-sm">Last Modified: {{ formatDate(wasm.lastModified) }}</div>
        </div>
      </div>
    </div>
  </div>
</template>


<script setup lang="ts">
import { getDB, type WasmFileOutputData } from '@/local_db/db';
import { getLogger } from '@/log';
import { onMounted, ref, watch } from 'vue';

const logger = getLogger('info');

const props = defineProps({
  isDarkMode: {
    type: Boolean,
    required: true,
  },
});

const emit = defineEmits(['wasm-uploaded', 'wasm-selected']);

const wasmName = ref('');
const selectedWasm = ref('');
const wasmFiles = ref<WasmFileOutputData[]>([]);
const selectedFile = ref<File | null>(null);
const prebuiltParsers = ref(['typescript', 'javascript']);

const onFileChange = (event: Event) => {
  selectedFile.value = (event.target as HTMLInputElement).files?.[0] || null;
};

const uploadWasm = async () => {
  const file = selectedFile.value;
  if (file && wasmName.value) {
    const db = await getDB();
    const name = wasmName.value;
    await db.saveWasmFile(file, name);
    await fetchWasmFiles();
    emit('wasm-uploaded', file);
    wasmName.value = '';
    selectedFile.value = null;
  }
};

const onWasmSelect = async (event: Event) => {
  const name = (event.target as HTMLSelectElement).value;
  if (prebuiltParsers.value.includes(name)) {
    const response = await fetch(`/wasm/tree-sitter-${name}.wasm`);
    const wasmBuffer = await response.arrayBuffer();
    const wasmFile = new File([wasmBuffer], `tree-sitter-${name}.wasm`);
    logger.info(`Selected pre-built parser: ${name}`);
    emit('wasm-selected', wasmFile);
  } else {
    const wasm = wasmFiles.value.find((w) => w.name === name);
    if (wasm) {
      emit('wasm-selected', wasm.attachment);
    }
  }
};

const formatFileSize = (size: number) => {
  const units = ['B', 'KB', 'MB', 'GB'];
  let index = 0;
  while (size >= 1024 && index < units.length - 1) {
    size /= 1024;
    index++;
  }
  return `${size.toFixed(2)} ${units[index]}`;
};

const formatDate = (timestamp: number) => {
  const date = new Date(timestamp);
  return date.toLocaleString();
};

const fetchWasmFiles = async () => {
  const db = await getDB();
  const docs = await Promise.all(await db.getWasmFiles());
  wasmFiles.value = docs;
};

const fetchLastSelectedParser = async () => {
  const db = await getDB();
  const lastSelectedParser = await db.getLastSelectedParser();
  if (lastSelectedParser) {
    selectedWasm.value = lastSelectedParser;
    onWasmSelect(new Event('change'));
  }
};

onMounted(async () => {
  await fetchWasmFiles();
  await fetchLastSelectedParser();
});

watch(selectedWasm, async (newValue) => {
  await fetchWasmFiles();
  const db = await getDB();
  await db.saveLastSelectedParser(newValue);
});
</script>